# all files / src/aggregators/is-performant/ index.js

100% Statements 14/14
100% Branches 0/0
100% Functions 4/4
100% Lines 14/14

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    81
    82
    83
    84
    85
    86
    87
    88
    89
    90
    91
    92
    93
    94
    95
    96
    97
    98
    99
    100
    101

    1×
    1×
    1×

    1×

    1×

    1×

    1×
    1×

    1×

    1×

    1×

    1×

    1×

    1×
     /**
     * @license
     * Copyright 2016 Google Inc. All rights reserved.
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     *     http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */

    'use strict';

    const Aggregate = require('../aggregate');
    const firstMeaningfulPaint = require('../../audits/performance/first-meaningful-paint');
    const speedIndexMetric = require('../../audits/performance/speed-index-metric');
    // TODO: https://github.com/GoogleChrome/lighthouse/issues/336
    // const inputReadinessMetric = require('../../audits/performance/input-readiness-metric');

    class IsPerformant extends Aggregate {

      /**
       * @override
       * @return {string}
       */
      static get name() {
        return 'Page load performance is fast';
      }

      /**
       * @override
       * @return {string}
       */
      static get description() {
        return `Users notice if sites and apps don't perform well. These top-level metrics capture
                the most important perceived performance concerns.`;
      }

      /**
       * @override
       * @return {!AggregationType}
       */
      static get type() {
        return Aggregate.TYPES.PWA;
      }

      /**
       * @override
       * @return {!AggregationCriteria}
       */
      static get criteria() {
        const criteria = {};
        criteria[firstMeaningfulPaint.meta.name] = {
          value: 100,
          weight: 1
        };
        criteria[speedIndexMetric.meta.name] = {
          value: 100,
          weight: 1
        };
        // criteria[inputReadinessMetric.meta.name] = {
        //   value: 100,
        //   weight: 1
        // };

        criteria['scrolling-60fps'] = {
          value: true,
          weight: 0,
          comingSoon: true,
          description: 'Content scrolls at 60fps',
          category: 'UX'
        };

        criteria['touch-150ms'] = {
          value: true,
          weight: 0,
          comingSoon: true,
          description: 'Touch input gets a response in < 150ms',
          category: 'UX'
        };

        criteria['fmp-no-jank'] = {
          value: true,
          weight: 0,
          comingSoon: true,
          description: 'App is interactive without jank after the first meaningful paint',
          category: 'UX'
        };

        return criteria;
      }
    }

    module.exports = IsPerformant;